Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3847)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3848)
@@ -1122,10 +1126,10 @@
     CHARACTER (LEN=*) ::  variable !< 
     CHARACTER (LEN=*) ::  dopr_unit
-    CHARACTER(len=16) ::  spec_name
+    CHARACTER (LEN=16) ::  spec_name
 
     INTEGER(iwp) ::  var_count, lsp  !<
 
 
-    spec_name = TRIM(variable(4:))    
+    spec_name = TRIM( variable(4:) )    
 
        IF (  .NOT.  air_chemistry )  THEN
@@ -1136,11 +1140,11 @@
 
        ELSE
-          DO lsp = 1, nspec
-             IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name ) ) THEN 
+          DO  lsp = 1, nspec
+             IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name ) )  THEN 
                 cs_pr_count = cs_pr_count+1
                 cs_pr_index(cs_pr_count) = lsp
                 dopr_index(var_count) = pr_palm+cs_pr_count  
                 dopr_unit  = 'ppm'
-                IF (spec_name(1:2) == 'PM')   THEN
+                IF (spec_name(1:2) == 'PM')  THEN
                      dopr_unit = 'kg m-3'
                 ENDIF
@@ -1153,5 +1157,5 @@
  END SUBROUTINE chem_check_data_output_pr
 
-!
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -1163,5 +1167,5 @@
     IMPLICIT NONE
 
-    LOGICAL       ::  found
+    LOGICAL  ::  found
     INTEGER (iwp) ::  lsp_usr      !< running index for user defined chem spcs 
     INTEGER (iwp) ::  lsp          !< running index for chem spcs.
@@ -1171,18 +1175,18 @@
        message_string = 'Chemical reactions: ON'
        CALL message( 'chem_check_parameters', 'CM0421', 0, 0, 0, 6, 0 )
-    ELSEIF ( .not. (chem_gasphase_on) ) THEN
+    ELSEIF ( .NOT. (chem_gasphase_on) )  THEN
        message_string = 'Chemical reactions: OFF'
        CALL message( 'chem_check_parameters', 'CM0422', 0, 0, 0, 6, 0 )
     ENDIF
-
+!
 !-- check for chemistry time-step
     IF ( call_chem_at_all_substeps )  THEN
        message_string = 'Chemistry is calculated at all meteorology time-step'
        CALL message( 'chem_check_parameters', 'CM0423', 0, 0, 0, 6, 0 )
-    ELSEIF ( .not. (call_chem_at_all_substeps) ) THEN
+    ELSEIF ( .not. (call_chem_at_all_substeps) )  THEN
        message_string = 'Sub-time-steps are skipped for chemistry time-steps'
        CALL message( 'chem_check_parameters', 'CM0424', 0, 0, 0, 6, 0 )
     ENDIF
-
+!
 !-- check for photolysis scheme 
     IF ( (photolysis_scheme /= 'simple') .AND. (photolysis_scheme /= 'constant')  )  THEN
@@ -1190,26 +1194,25 @@
        CALL message( 'chem_check_parameters', 'CM0425', 1, 2, 0, 6, 0 )
     ENDIF
-
+!
 !-- check for  decycling of chem species
-    IF ( (.not. any(decycle_method == 'neumann') ) .AND. (.not. any(decycle_method == 'dirichlet') ) )   THEN
+    IF ( (.NOT. any(decycle_method == 'neumann') ) .AND. (.NOT. any(decycle_method == 'dirichlet') ) )  THEN
        message_string = 'Incorrect boundary conditions. Only neumann or '   &
                 // 'dirichlet &available for decycling chemical species '
        CALL message( 'chem_check_parameters', 'CM0426', 1, 2, 0, 6, 0 )
     ENDIF
+!
 !-- check for chemical mechanism used 
     CALL get_mechanism_name
-    IF (chem_mechanism /= trim(cs_mech) )  THEN
+    IF ( chem_mechanism /= TRIM( cs_mech ) )  THEN
        message_string = 'Incorrect chemistry mechanism selected, check spelling in namelist and/or chem_gasphase_mod'
        CALL message( 'chem_check_parameters', 'CM0462', 1, 2, 0, 6, 0 )
     ENDIF
-
-
-!---------------------
+!
 !-- chem_check_parameters is called before the array chem_species is allocated!
 !-- temporary switch of this part of the check
 !    RETURN                !bK commented
+
     CALL chem_init_internal
-!---------------------
-
+!
 !-- check for initial chem species input
     lsp_usr = 1
@@ -1217,32 +1220,32 @@
     DO WHILE ( cs_name (lsp_usr) /= 'novalue')
        found = .FALSE.
-       DO lsp = 1, nvar
-          IF ( TRIM(cs_name (lsp_usr)) == TRIM(chem_species(lsp)%name) ) THEN
+       DO  lsp = 1, nvar
+          IF ( TRIM( cs_name (lsp_usr) ) == TRIM( chem_species(lsp)%name) )  THEN
              found = .TRUE.
              EXIT
           ENDIF 
        ENDDO
-       IF ( .not. found ) THEN
-          message_string = 'Unused/incorrect input for initial surface value: ' // TRIM(cs_name(lsp_usr))
+       IF ( .NOT.  found )  THEN
+          message_string = 'Unused/incorrect input for initial surface value: ' //     &
+                            TRIM( cs_name(lsp_usr) )
           CALL message( 'chem_check_parameters', 'CM0427', 1, 2, 0, 6, 0 )
        ENDIF
        lsp_usr = lsp_usr + 1
     ENDDO
-
+!
 !-- check for surface  emission flux chem species
-
     lsp_usr = 1
     lsp     = 1
     DO WHILE ( surface_csflux_name (lsp_usr) /= 'novalue')
        found = .FALSE.
-       DO lsp = 1, nvar
-          IF ( TRIM(surface_csflux_name (lsp_usr)) == TRIM(chem_species(lsp)%name) ) THEN
+       DO  lsp = 1, nvar
+          IF ( TRIM( surface_csflux_name (lsp_usr) ) == TRIM( chem_species(lsp)%name ) )  THEN
              found = .TRUE.
              EXIT
           ENDIF 
        ENDDO
-       IF ( .not. found ) THEN
+       IF ( .NOT.  found )  THEN
           message_string = 'Unused/incorrect input of chemical species for surface emission fluxes: '  &
-                            // TRIM(surface_csflux_name(lsp_usr))
+                            // TRIM( surface_csflux_name(lsp_usr) )
           CALL message( 'chem_check_parameters', 'CM0428', 1, 2, 0, 6, 0 )
        ENDIF
@@ -1252,7 +1255,6 @@
  END SUBROUTINE chem_check_parameters
 
-!
-!------------------------------------------------------------------------------!
-!
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -1260,5 +1262,4 @@
 !> @todo: Remove "mode" from argument list, not used.
 !------------------------------------------------------------------------------!
-    
  SUBROUTINE chem_data_output_2d( av, variable, found, grid, mode, local_pf,   &
                                   two_d, nzb_do, nzt_do, fill_value )
@@ -1281,7 +1282,7 @@
     REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf  
 
-    !
-    !-- local variables.
-    CHARACTER(len=16)    ::  spec_name
+!
+!-- local variables.
+    CHARACTER(LEN=16)    ::  spec_name
     INTEGER(iwp) ::  lsp
     INTEGER(iwp) ::  i               !< grid index along x-direction
@@ -1289,5 +1290,4 @@
     INTEGER(iwp) ::  k               !< grid index along z-direction
     INTEGER(iwp) ::  char_len        !< length of a character string
-
 !
 !-- Next statement is to avoid compiler warnings about unused variables
@@ -1295,18 +1295,18 @@
 
     found = .FALSE.
-    char_len  = LEN_TRIM(variable)
+    char_len  = LEN_TRIM( variable )
 
     spec_name = TRIM( variable(4:char_len-3) )
 
-       DO lsp=1,nspec
-          IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name)    .AND.                             &
-                ( (variable(char_len-2:) == '_xy')               .OR.                              &
-                  (variable(char_len-2:) == '_xz')               .OR.                              &
-                  (variable(char_len-2:) == '_yz') ) )               THEN             
+       DO  lsp=1,nspec
+          IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name )  .AND.                           &
+                ( (variable(char_len-2:) == '_xy')  .OR.                                           &
+                  (variable(char_len-2:) == '_xz')  .OR.                                           &
+                  (variable(char_len-2:) == '_yz') ) )  THEN             
 !
 !--   todo: remove or replace by "CALL message" mechanism (kanani)
-!                    IF(myid == 0)  WRITE(6,*) 'Output of species ' // TRIM(variable)  //               &
-!                                                             TRIM(chem_species(lsp)%name)       
-             IF (av == 0) THEN
+!                    IF(myid == 0)  WRITE(6,*) 'Output of species ' // TRIM( variable )  //       &
+!                                                             TRIM( chem_species(lsp)%name )       
+             IF (av == 0)  THEN
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
@@ -1316,6 +1316,4 @@
                                               REAL( fill_value, KIND = wp ),                       &
                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-
-
                       ENDDO
                    ENDDO
@@ -1334,6 +1332,6 @@
                 ENDDO
              ENDIF
-              grid = 'zu'           
-              found = .TRUE.
+             grid = 'zu'           
+             found = .TRUE.
           ENDIF
        ENDDO
@@ -1343,14 +1341,11 @@
  END SUBROUTINE chem_data_output_2d      
 
-!
-!------------------------------------------------------------------------------!
-!
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Subroutine defining 3D output variables for chemical species
 !------------------------------------------------------------------------------!
-
  SUBROUTINE chem_data_output_3d( av, variable, found, local_pf, fill_value, nzb_do, nzt_do )
-
 
     USE indices
@@ -1372,8 +1367,7 @@
     REAL(wp)             ::  fill_value   !<
     REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf 
-
-
-    !-- local variables
-    CHARACTER(len=16)    ::  spec_name
+!
+!-- local variables
+    CHARACTER(LEN=16)    ::  spec_name
     INTEGER(iwp)         ::  i
     INTEGER(iwp)         ::  j
@@ -1385,47 +1379,47 @@
 
     found = .FALSE.
-    IF ( .NOT. (variable(1:3) == 'kc_' .OR. variable(1:3) == 'em_' ) ) THEN
+    IF ( .NOT. (variable(1:3) == 'kc_' .OR. variable(1:3) == 'em_' ) )  THEN
        RETURN
     ENDIF
 
-    spec_name = TRIM(variable(4:))
-
-    IF ( variable(1:3) == 'em_' ) THEN
-
-      local_pf = 0.0_wp
-
-      DO lsp = 1, nvar   !!! cssws - nvar species, chem_species - nspec species !!!
-         IF ( TRIM(spec_name) == TRIM(chem_species(lsp)%name) )   THEN
-            !
-            !-- no average for now
-            DO m = 1, surf_usm_h%ns
-               local_pf(surf_usm_h%i(m),surf_usm_h%j(m),surf_usm_h%k(m)) = &
-                  local_pf(surf_usm_h%i(m),surf_usm_h%j(m),surf_usm_h%k(m)) + surf_usm_h%cssws(lsp,m)
-            ENDDO
-            DO m = 1, surf_lsm_h%ns
-               local_pf(surf_lsm_h%i(m),surf_lsm_h%j(m),surf_lsm_h%k(m)) = &
+    spec_name = TRIM( variable(4:) )
+
+    IF ( variable(1:3) == 'em_' )  THEN
+
+       local_pf = 0.0_wp
+
+       DO  lsp = 1, nvar   !!! cssws - nvar species, chem_species - nspec species !!!
+          IF ( TRIM( spec_name ) == TRIM( chem_species(lsp)%name) )  THEN
+!
+!--          no average for now
+             DO  m = 1, surf_usm_h%ns
+                local_pf(surf_usm_h%i(m),surf_usm_h%j(m),surf_usm_h%k(m)) = &
+                   local_pf(surf_usm_h%i(m),surf_usm_h%j(m),surf_usm_h%k(m)) + surf_usm_h%cssws(lsp,m)
+             ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                local_pf(surf_lsm_h%i(m),surf_lsm_h%j(m),surf_lsm_h%k(m)) = &
                   local_pf(surf_lsm_h%i(m),surf_lsm_h%j(m),surf_lsm_h%k(m)) + surf_lsm_h%cssws(lsp,m)
-            ENDDO
-            DO l = 0, 3
-               DO m = 1, surf_usm_v(l)%ns
-                  local_pf(surf_usm_v(l)%i(m),surf_usm_v(l)%j(m),surf_usm_v(l)%k(m)) = &
+             ENDDO
+             DO  l = 0, 3
+                DO  m = 1, surf_usm_v(l)%ns
+                   local_pf(surf_usm_v(l)%i(m),surf_usm_v(l)%j(m),surf_usm_v(l)%k(m)) = &
                      local_pf(surf_usm_v(l)%i(m),surf_usm_v(l)%j(m),surf_usm_v(l)%k(m)) + surf_usm_v(l)%cssws(lsp,m)
-               ENDDO
-               DO m = 1, surf_lsm_v(l)%ns
-                  local_pf(surf_lsm_v(l)%i(m),surf_lsm_v(l)%j(m),surf_lsm_v(l)%k(m)) = &
-                     local_pf(surf_lsm_v(l)%i(m),surf_lsm_v(l)%j(m),surf_lsm_v(l)%k(m)) + surf_lsm_v(l)%cssws(lsp,m)
-               ENDDO
-            ENDDO
-            found = .TRUE.
-         ENDIF
-      ENDDO
+                ENDDO
+                DO  m = 1, surf_lsm_v(l)%ns
+                   local_pf(surf_lsm_v(l)%i(m),surf_lsm_v(l)%j(m),surf_lsm_v(l)%k(m)) = &
+                      local_pf(surf_lsm_v(l)%i(m),surf_lsm_v(l)%j(m),surf_lsm_v(l)%k(m)) + surf_lsm_v(l)%cssws(lsp,m)
+                ENDDO
+             ENDDO
+             found = .TRUE.
+          ENDIF
+       ENDDO
     ELSE
-      DO lsp=1,nspec
-         IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
+      DO  lsp = 1, nspec
+         IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name) )  THEN
 !
 !--   todo: remove or replace by "CALL message" mechanism (kanani)
-!              IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM(variable)  //  &
-!                                                           TRIM(chem_species(lsp)%name)       
-            IF (av == 0) THEN
+!              IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM( variable )  // &
+!                                                           TRIM( chem_species(lsp)%name )       
+            IF (av == 0)  THEN
                DO  i = nxl, nxr
                   DO  j = nys, nyn
@@ -1440,4 +1434,5 @@
 
             ELSE
+
                DO  i = nxl, nxr
                   DO  j = nys, nyn
@@ -1459,12 +1454,11 @@
 
  END SUBROUTINE chem_data_output_3d
-!
-!------------------------------------------------------------------------------!
-!
+
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Subroutine defining mask output variables for chemical species
 !------------------------------------------------------------------------------!
-    
  SUBROUTINE chem_data_output_mask( av, variable, found, local_pf )
 
@@ -1477,15 +1471,13 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=5) ::  grid        !< flag to distinquish between staggered grids
-
-    CHARACTER (LEN=*)::  variable    !< 
-    INTEGER(iwp)     ::  av          !< flag to control data output of instantaneous or time-averaged data
-    LOGICAL          ::  found       !< 
+    CHARACTER(LEN=5)  ::  grid        !< flag to distinquish between staggered grids
+    CHARACTER(LEN=*)  ::  variable    !< 
+    INTEGER(iwp)  ::  av              !< flag to control data output of instantaneous or time-averaged data
+    LOGICAL ::  found
     REAL(wp), DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  &
               local_pf   !< 
-
-
-    !-- local variables.
-    CHARACTER(len=16)    ::  spec_name
+!
+!-- local variables.
+    CHARACTER(LEN=16)  ::  spec_name
     INTEGER(iwp) ::  lsp
     INTEGER(iwp) ::  i               !< grid index along x-direction
@@ -1495,15 +1487,15 @@
 
     found = .TRUE.
-    grid  = 's'
+    grid = 's'
 
     spec_name = TRIM( variable(4:) )
 
-    DO lsp=1,nspec
-       IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name) )               THEN             
+    DO  lsp=1,nspec
+       IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name) )  THEN             
 !
 !-- todo: remove or replace by "CALL message" mechanism (kanani)
-!              IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM(variable)  // &
-!                                                        TRIM(chem_species(lsp)%name)       
-          IF (av == 0) THEN
+!              IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM( variable )  // &
+!                                                        TRIM( chem_species(lsp)%name )       
+          IF (av == 0)  THEN
              IF ( .NOT. mask_surface(mid) )  THEN
 
@@ -1582,5 +1574,4 @@
              ENDIF
 
-
           ENDIF
           found = .FALSE.
@@ -1592,7 +1583,6 @@
  END SUBROUTINE chem_data_output_mask      
 
-!
-!------------------------------------------------------------------------------!
-!
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -1612,5 +1602,5 @@
     found  = .TRUE.
 
-    IF ( var(1:3) == 'kc_' .OR. var(1:3) == 'em_' )   THEN                   !< always the same grid for chemistry variables
+    IF ( var(1:3) == 'kc_' .OR. var(1:3) == 'em_' )  THEN                   !< always the same grid for chemistry variables
        grid_x = 'x'
        grid_y = 'y'
@@ -1625,7 +1615,7 @@
 
  END SUBROUTINE chem_define_netcdf_grid
-!
-!------------------------------------------------------------------------------!
-!
+
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -1637,15 +1627,15 @@
 
     INTEGER(iwp), INTENT(IN) ::  io            !< Unit of the output file
-    INTEGER(iwp)             :: lsp            !< running index for chem spcs
-    INTEGER(iwp)             :: cs_fixed 
-    CHARACTER (LEN=80)       :: docsflux_chr
-    CHARACTER (LEN=80)       :: docsinit_chr
+    INTEGER(iwp)  :: lsp                       !< running index for chem spcs
+    INTEGER(iwp)  :: cs_fixed 
+    CHARACTER (LEN=80)  :: docsflux_chr
+    CHARACTER (LEN=80)  :: docsinit_chr
 !
 ! Get name of chemical mechanism from chem_gasphase_mod
     CALL get_mechanism_name
-
+!
 !-- Write chemistry model  header
     WRITE( io, 1 )
-
+!
 !-- Gasphase reaction status
     IF ( chem_gasphase_on )  THEN 
@@ -1654,9 +1644,8 @@
        WRITE( io, 3 )
     ENDIF
-
 !
 !-- Chemistry time-step
     WRITE ( io, 4 ) cs_time_step
-
+!
 !-- Emission mode info
     IF ( mode_emis == "DEFAULT" )  THEN 
@@ -1667,12 +1656,12 @@
        WRITE( io, 7 )
     ENDIF 
-
+!
 !-- Photolysis scheme info
-    IF ( photolysis_scheme == "simple" )      THEN
+    IF ( photolysis_scheme == "simple" )  THEN
        WRITE( io, 8 ) 
-    ELSEIF (photolysis_scheme == "constant" ) THEN
+    ELSEIF (photolysis_scheme == "constant" )  THEN
        WRITE( io, 9 )
     ENDIF
-
+!
 !-- Emission flux info
     lsp = 1
@@ -1681,6 +1670,6 @@
        docsflux_chr = TRIM( docsflux_chr ) // ' ' // TRIM( surface_csflux_name(lsp) ) // ','  
        IF ( LEN_TRIM( docsflux_chr ) >= 75 )  THEN
-        WRITE ( io, 10 )  docsflux_chr
-        docsflux_chr = '       '
+          WRITE ( io, 10 )  docsflux_chr
+          docsflux_chr = '       '
        ENDIF
        lsp = lsp + 1
@@ -1690,6 +1679,5 @@
        WRITE ( io, 10 )  docsflux_chr
     ENDIF
-
-
+!
 !-- initializatoin of Surface and profile chemical species
 
@@ -1708,5 +1696,5 @@
        WRITE ( io, 11 )  docsinit_chr
     ENDIF
-
+!
 !-- number of variable and fix chemical species and number of reactions
     cs_fixed = nspec - nvar
@@ -1734,7 +1722,6 @@
  END SUBROUTINE chem_header
 
-!
-!------------------------------------------------------------------------------!
-!
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -1742,12 +1729,11 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE chem_init_arrays
-
+!
 !-- Please use this place to allocate required arrays
 
  END SUBROUTINE chem_init_arrays
 
-!
-!------------------------------------------------------------------------------!
-!
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -1767,5 +1753,4 @@
     INTEGER(iwp) ::  j !< running index y dimension
     INTEGER(iwp) ::  n !< running index for chemical species
-
 !
 !-- Next statement is to avoid compiler warning about unused variables
@@ -1774,6 +1759,4 @@
            ilu_urban ) == 0 )  CONTINUE
          
-
-
     IF ( emissions_anthropogenic )  CALL chem_emissions_init
 !
@@ -1796,7 +1779,6 @@
  END SUBROUTINE chem_init
 
-!
-!------------------------------------------------------------------------------!
-!
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -1813,5 +1795,4 @@
 
     IMPLICIT NONE
-
 !
 !-- Local variables
@@ -1821,5 +1802,5 @@
     INTEGER(iwp) ::  lpr_lev           !< running index for chem spcs profile level
 
-    IF ( emissions_anthropogenic ) THEN
+    IF ( emissions_anthropogenic )  THEN
        CALL netcdf_data_input_chemistry_data( chem_emis_att, chem_emis )
     ENDIF
@@ -1874,8 +1855,8 @@
 
     ENDDO
-
 !
 !-- Initial concentration of profiles is prescribed by parameters cs_profile
 !-- and cs_heights in the namelist &chemistry_parameters
+
     CALL chem_init_profiles
 !    
@@ -1892,13 +1873,9 @@
        ENDDO
     ENDIF
-
-
-
 !
 !-- Initialize model variables
     IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
          TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
-
-
+!
 !--    First model run of a possible job queue.
 !--    Initial profiles of the variables must be computed.
@@ -1907,5 +1884,5 @@
 !
 !--       Transfer initial profiles to the arrays of the 3D model
-          DO lsp = 1, nspec
+          DO  lsp = 1, nspec
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
@@ -1921,5 +1898,5 @@
           CALL location_message( 'initializing with constant chemistry profiles', .FALSE. )
 
-          DO lsp = 1, nspec 
+          DO  lsp = 1, nspec 
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
@@ -1930,9 +1907,8 @@
 
        ENDIF
-
 !
 !--    If required, change the surface chem spcs at the start of the 3D run
-       IF ( cs_surface_initial_change(1) /= 0.0_wp ) THEN            
-          DO lsp = 1, nspec 
+       IF ( cs_surface_initial_change(1) /= 0.0_wp )  THEN            
+          DO  lsp = 1, nspec 
              chem_species(lsp)%conc(nzb,:,:) = chem_species(lsp)%conc(nzb,:,:) +  &
                                                cs_surface_initial_change(lsp)
@@ -1941,5 +1917,5 @@
 !
 !--    Initiale old and new time levels. 
-       DO lsp = 1, nvar
+       DO  lsp = 1, nvar
           chem_species(lsp)%tconc_m = 0.0_wp                      
           chem_species(lsp)%conc_p  = chem_species(lsp)%conc     
@@ -1948,15 +1924,12 @@
     ENDIF
 
-
-
-!--- new code add above this line
-    DO lsp = 1, nphot
+    DO  lsp = 1, nphot
        phot_frequen(lsp)%name = phot_names(lsp)
 !
 !-- todo: remove or replace by "CALL message" mechanism (kanani)
-!         IF( myid == 0 )  THEN
-!            WRITE(6,'(a,i4,3x,a)')  'Photolysis: ',lsp,TRIM(phot_names(lsp))
-!         ENDIF 
-          phot_frequen(lsp)%freq(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => freq_1(:,:,:,lsp)
+!--       IF( myid == 0 )  THEN
+!--          WRITE(6,'(a,i4,3x,a)')  'Photolysis: ',lsp,TRIM( phot_names(lsp) )
+!--       ENDIF 
+          phot_frequen(lsp)%freq(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  =>  freq_1(:,:,:,lsp)
     ENDDO
 
@@ -1967,7 +1940,6 @@
  END SUBROUTINE chem_init_internal
 
-!
-!------------------------------------------------------------------------------!
-!
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -1976,32 +1948,34 @@
 !> analogue to parameters u_profile, v_profile and uv_heights)
 !------------------------------------------------------------------------------!
- SUBROUTINE chem_init_profiles              !< SUBROUTINE is called from chem_init in case of 
-   !< TRIM( initializing_actions ) /= 'read_restart_data'
-   !< We still need to see what has to be done in case of restart run
+ SUBROUTINE chem_init_profiles              
+!
+!-- SUBROUTINE is called from chem_init in case of TRIM( initializing_actions ) /= 'read_restart_data'
+!< We still need to see what has to be done in case of restart run
+
     USE chem_modules
 
     IMPLICIT NONE
-
-    !-- Local variables
+!
+!-- Local variables
     INTEGER ::  lsp        !< running index for number of species in derived data type species_def
     INTEGER ::  lsp_usr     !< running index for number of species (user defined)  in cs_names, cs_profiles etc
     INTEGER ::  lpr_lev    !< running index for profile level for each chem spcs. 
     INTEGER ::  npr_lev    !< the next available profile lev
-
-    !-----------------
-    !-- Parameter "cs_profile" and "cs_heights" are used to prescribe user defined initial profiles
-    !-- and heights. If parameter "cs_profile" is not prescribed then initial surface values
-    !-- "cs_surface" are used as constant initial profiles for each species. If "cs_profile" and
-    !-- "cs_heights" are prescribed, their values will!override the constant profile given by
-    !-- "cs_surface".
-    ! 
+!
+!-- Parameter "cs_profile" and "cs_heights" are used to prescribe user defined initial profiles
+!-- and heights. If parameter "cs_profile" is not prescribed then initial surface values
+!-- "cs_surface" are used as constant initial profiles for each species. If "cs_profile" and
+!-- "cs_heights" are prescribed, their values will!override the constant profile given by
+!-- "cs_surface".
     IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN 
        lsp_usr = 1
        DO  WHILE ( TRIM( cs_name( lsp_usr ) ) /= 'novalue' )   !'novalue' is the default
           DO  lsp = 1, nspec                                !
-             !-- create initial profile (conc_pr_init) for each chemical species
+!
+!--          create initial profile (conc_pr_init) for each chemical species
              IF ( TRIM( chem_species(lsp)%name ) == TRIM( cs_name(lsp_usr) ) )  THEN   !
-                IF ( cs_profile(lsp_usr,1) == 9999999.9_wp ) THEN
-                   !-- set a vertically constant profile based on the surface conc (cs_surface(lsp_usr)) of each species
+                IF ( cs_profile(lsp_usr,1) == 9999999.9_wp )  THEN
+!
+!--               set a vertically constant profile based on the surface conc (cs_surface(lsp_usr)) of each species
                    DO lpr_lev = 0, nzt+1
                       chem_species(lsp)%conc_pr_init(lpr_lev) = cs_surface(lsp_usr)
@@ -2016,5 +1990,5 @@
 
                    npr_lev = 1
-                   !                     chem_species(lsp)%conc_pr_init(0) = 0.0_wp
+!                   chem_species(lsp)%conc_pr_init(0) = 0.0_wp
                    DO  lpr_lev = 1, nz+1
                       IF ( npr_lev < 100 )  THEN
@@ -2028,5 +2002,5 @@
                          ENDDO
                       ENDIF
-                      IF ( npr_lev < 100  .AND.  cs_heights(lsp_usr, npr_lev + 1) /= 9999999.9_wp )  THEN
+                      IF ( npr_lev < 100  .AND.  cs_heights(lsp_usr,npr_lev+1) /= 9999999.9_wp )  THEN
                          chem_species(lsp)%conc_pr_init(lpr_lev) = cs_profile(lsp_usr, npr_lev) +       &
                               ( zu(lpr_lev) - cs_heights(lsp_usr, npr_lev) ) /                          &
@@ -2038,7 +2012,8 @@
                    ENDDO
                 ENDIF
-                !-- If a profile is prescribed explicity using cs_profiles and cs_heights, then  
-                !-- chem_species(lsp)%conc_pr_init is populated with the specific "lsp" based
-                !-- on the cs_profiles(lsp_usr,:)  and cs_heights(lsp_usr,:). 
+!
+!--          If a profile is prescribed explicity using cs_profiles and cs_heights, then  
+!--          chem_species(lsp)%conc_pr_init is populated with the specific "lsp" based
+!--          on the cs_profiles(lsp_usr,:)  and cs_heights(lsp_usr,:). 
              ENDIF
           ENDDO
@@ -2048,12 +2023,11 @@
 
  END SUBROUTINE chem_init_profiles
- !
- !------------------------------------------------------------------------------!
- !
- ! Description:
- ! ------------
- !> Subroutine to integrate chemical species in the given chemical mechanism
- !------------------------------------------------------------------------------!
-
+
+ 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Subroutine to integrate chemical species in the given chemical mechanism
+!------------------------------------------------------------------------------!
  SUBROUTINE chem_integrate_ij( i, j )
 
@@ -2068,6 +2042,6 @@
     INTEGER,INTENT(IN)       :: i
     INTEGER,INTENT(IN)       :: j
-
-    !--   local variables
+!
+!--   local variables
     INTEGER(iwp) ::  lsp                                                     !< running index for chem spcs.
     INTEGER(iwp) ::  lph                                                     !< running index for photolysis frequencies
@@ -2096,22 +2070,21 @@
     REAL(wp),DIMENSION(size(rcntrl)) :: rcntrl_local
 
-
     REAL(kind=wp)  :: dt_chem                                             
-
 !
 !-- Set chem_gasphase_on to .FALSE. if you want to skip computation of gas phase chemistry
-    IF (chem_gasphase_on) THEN
+    IF (chem_gasphase_on)  THEN
        nacc = 0
        nrej = 0
 
        tmp_temp(:) = pt(nzb+1:nzt,j,i) * exner(nzb+1:nzt)
-       !
-       !--       ppm to molecules/cm**3
-       !--       tmp_fact = 1.e-6_wp*6.022e23_wp/(22.414_wp*1000._wp) * 273.15_wp * hyp(nzb+1:nzt)/( 101300.0_wp * tmp_temp )  
+!
+!--    convert ppm to molecules/cm**3
+!--    tmp_fact = 1.e-6_wp*6.022e23_wp/(22.414_wp*1000._wp) * 273.15_wp * 
+!--               hyp(nzb+1:nzt)/( 101300.0_wp * tmp_temp )  
        conv = ppm2fr * xna / vmolcm
        tmp_fact(:) = conv * t_std * hyp(nzb+1:nzt) / (tmp_temp(:) * p_std)
        tmp_fact_i = 1.0_wp/tmp_fact
 
-       IF ( humidity ) THEN
+       IF ( humidity )  THEN
           IF ( bulk_cloud_model )  THEN
              tmp_qvap(:) = ( q(nzb+1:nzt,j,i) - ql(nzb+1:nzt,j,i) ) *  &
@@ -2124,5 +2097,5 @@
        ENDIF
 
-       DO lsp = 1,nspec
+       DO  lsp = 1,nspec
           tmp_conc(:,lsp) = chem_species(lsp)%conc(nzb+1:nzt,j,i) * tmp_fact(:) 
        ENDDO
@@ -2131,11 +2104,6 @@
           tmp_phot(:,lph) = phot_frequen(lph)%freq(nzb+1:nzt,j,i)               
        ENDDO
-       !
-       !--   todo: remove (kanani)
-       !           IF(myid == 0 .AND. chem_debug0 ) THEN
-       !              IF (i == 10 .AND. j == 10) WRITE(0,*) 'begin chemics step ',dt_3d
-       !           ENDIF
-
-       !--       Compute length of time step
+!
+!--    Compute length of time step
        IF ( call_chem_at_all_substeps )  THEN
           dt_chem = dt_3d * weight_pres(intermediate_timestep_count)
@@ -2146,5 +2114,5 @@
        cs_time_step = dt_chem
 
-       IF(maxval(rcntrl) > 0.0)   THEN    ! Only if rcntrl is set
+       IF(maxval(rcntrl) > 0.0)  THEN    ! Only if rcntrl is set
           IF( time_since_reference_point <= 2*dt_3d)  THEN
              rcntrl_local = 0
@@ -2159,5 +2127,5 @@
             icntrl_i = icntrl, rcntrl_i = rcntrl_local, xnacc = nacc, xnrej = nrej, istatus=istatus )
 
-       DO lsp = 1,nspec
+       DO  lsp = 1,nspec
           chem_species(lsp)%conc (nzb+1:nzt,j,i) = tmp_conc(:,lsp) * tmp_fact_i(:)
        ENDDO
@@ -2168,11 +2136,11 @@
     RETURN
  END SUBROUTINE chem_integrate_ij
- !
- !------------------------------------------------------------------------------!
- !
- ! Description:
- ! ------------
- !> Subroutine defining parin for &chemistry_parameters for chemistry model
- !------------------------------------------------------------------------------!
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Subroutine defining parin for &chemistry_parameters for chemistry model
+!------------------------------------------------------------------------------!
  SUBROUTINE chem_parin
 
